//+------------------------------------------------------------------+
//|                                                      LRMA-ap.mq4 |
//|                                             Copyright  2007, AP |
//|                                                olgapob33@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Aleksandr Pak"
#property link      "ekr-ap@mail.ru"


#property indicator_chart_window

#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Aqua
#property indicator_color3 Aqua


extern int MA=20;
extern int MA_StdDev=10;
extern double mastab.otklonenia=5.0;
extern int Ma.OR.Lrma=0;      //0=MA    METODb, _PRICE
extern int Metod_Std.0123=2; //0..3   SMA, EMA, SMMA, LWMA 


extern double a =3.;
//       LRMA
extern int METODa=3;  //0..3   SMA, EMA, SMMA, LWMA    (3= for LRMA)
extern int METODb=0;  //0..3    SMA, EMA, SMMA, LWMA   (0= for LRMA)
extern int _PRICE =0;  // 0...6  = Close, Open, High, Low, HC/2, HLC/3, HLCC/4      


double lrma[],bandsH[],bandsL[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetIndexBuffer(0,lrma);          
   SetIndexStyle(0,DRAW_LINE);   
   
   SetIndexBuffer(1,bandsH);          
   SetIndexStyle(1,DRAW_LINE);   
   SetIndexBuffer(2,bandsL);          
   SetIndexStyle(2,DRAW_LINE);   
   
 if(METODa<0||METODa>3) METODa=0;  //  
 if(METODb<0||METODb>3) METODb=0;  //  
 if(_PRICE<0||_PRICE>6) _PRICE=0;
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int i;
   int    counted_bars=IndicatorCounted();
   double b,r;
               b=a-1.;
      if(Ma.OR.Lrma==0)
            {
            for(i=0;i<Bars-counted_bars-1-MA;i++) 
                  lrma[i]= iMA(NULL,0,MA,0,METODb,_PRICE,i); 
                
            } else
            {
               
               for(i=0;i<Bars-counted_bars-1-MA;i++) 
                  lrma[i]= a*iMA(NULL,0,MA,0,METODa,_PRICE,i)
                  -b*iMA(NULL,0,MA,0,METODb,_PRICE,i); 
            }
       for(i=0;i<Bars-counted_bars-1-MA;i++) 
       {
     //   r= mastab*iStdDev(NULL,0,MA_StdDev,0,2,0,i);   
      r=mastab.otklonenia*iStdDevOnArray(lrma,0,MA_StdDev,0,Metod_Std.0123,i);   
        bandsH[i]=r+lrma[i];
        bandsL[i]=-r+lrma[i];    
        }    
             
   return(0);
  }






//+------------------------------------------------------------------+